# Camera hardware decode sample

## Notice
- OSDK run platform support: manifold 2g
- Aircraft support : M200 V2, M300 RTK
- Payload support : H20, Z30

## Environment prepare

### Manifold 2g gstreamer install

Manifold-2g(TX2) have already install gstreamer and support hardware acceleration. Just need install lib support for plugin base by follow command:
```
sudo apt-get install libgstreamer-plugins-base1.0
```

Check if necessary elements are installed by gst-inspect-1.0:
```
gst-inspect-1.0 | grep -E "h264parse|omxh264dec|nveglglessink"
```


### Sample prepare
1. Move this directory to onboard-sdk/sample/platform/linux/advanced-sensing/
2. Change onboard-sdk/sample/platform/linux/advanced-sensing/CMakeLists.txt , add:
```
add_subdirectory(camera_h264_hardware_decode_sample)
```

## Build and run
### Build
```
cd onboard-sdk/
mkdir build
cd build
cmake ..
make -j6 camera-h264-hardware-decode-sample
```
### Add UserConfig.txt
Add UserConfig.txt to onboard-sdk/build/bin

### Run sample
```
cd onboard-sdk/build/bin
./camera-h264-hardware-decode-sample
```
Choose mounted camera by input 'a', 'b', 'c'; and quit sample by input 'q'
```
| Available commands:                                             |
| [a] Start main camera H264 hardware decode sample               |
| [b] Start vice camera H264 hardware decode sample               |
| [c] Start top camera H264 hardware decode sample                |
| [q] Stop camera H264 hardware decode sample                     |
```
