/**
 ********************************************************************
 * @file    camera_stream_show.h
 * @brief   This is the header file for "camera_stream_show.c", defining the structure and
 * (exported) function prototypes.
 *
 * @copyright (c) 2018 DJI. All rights reserved.
 *
 * All information contained herein is, and remains, the property of DJI.
 * The intellectual and technical concepts contained herein are proprietary
 * to DJI and may be covered by U.S. and foreign patents, patents in process,
 * and protected by trade secret or copyright law.  Dissemination of this
 * information, including but not limited to data and other proprietary
 * material(s) incorporated within the information, in any form, is strictly
 * prohibited without the express written consent of DJI.
 *
 * If you receive this source code without DJI’s authorization, you may not
 * further disseminate the information, and you must immediately remove the
 * source code and notify DJI of its removal. DJI reserves the right to pursue
 * legal actions against you for any loss(es) or damage(s) caused by your
 * failure to do so.
 *
 *********************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef CAMERA_STREAM_SHOW_H
#define CAMERA_STREAM_SHOW_H

/* Includes ------------------------------------------------------------------*/
#include <dji_camera_manager.hpp>
#include <thread>
#include "camera_h264_hardware_decoder.hpp"
#include <gst/gst.h>

using namespace DJI;
using namespace DJI::OSDK;

/* Exported constants --------------------------------------------------------*/

/* Exported types ------------------------------------------------------------*/
class CameraStreamShow {
public:
	CameraStreamShow();
	~CameraStreamShow();
	ErrorCode::ErrorCodeType ShowImage(const T_Image *image);

private:
	GstElement *m_gstShowPipeline, *m_gstShowAppSrc, *m_gstShowCapsfilter, *m_gstShowSink;
	char m_currentShowImageFormat[16];
	int m_currentShowImageHeight;
	int m_currentShowImageWidth;

	ErrorCode::ErrorCodeType CreateShowPipeline();
	ErrorCode::ErrorCodeType DestroyShowPipeline();
	ErrorCode::ErrorCodeType RestartShowPipeline();
};

#endif // CAMERA_STREAM_SHOW_H
/************************ (C) COPYRIGHT DJI Innovations *******END OF FILE******/
