/**
 ********************************************************************
 * @file    h264_idr_frame.h
 * @brief   This is the header file for "h264_idr_frame.c", defining the structure and
 * (exported) function prototypes.
 *
 * @copyright (c) 2018 DJI. All rights reserved.
 *
 * All information contained herein is, and remains, the property of DJI.
 * The intellectual and technical concepts contained herein are proprietary
 * to DJI and may be covered by U.S. and foreign patents, patents in process,
 * and protected by trade secret or copyright law.  Dissemination of this
 * information, including but not limited to data and other proprietary
 * material(s) incorporated within the information, in any form, is strictly
 * prohibited without the express written consent of DJI.
 *
 * If you receive this source code without DJI’s authorization, you may not
 * further disseminate the information, and you must immediately remove the
 * source code and notify DJI of its removal. DJI reserves the right to pursue
 * legal actions against you for any loss(es) or damage(s) caused by your
 * failure to do so.
 *
 *********************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef H264_IDR_FRAME_H
#define H264_IDR_FRAME_H

/* Includes ------------------------------------------------------------------*/
#include <cstdint>
#include <dji_error.hpp>

/* Exported constants --------------------------------------------------------*/
using namespace DJI;
using namespace DJI::OSDK;

/* Exported types ------------------------------------------------------------*/
enum IdrFrameType {
	IDR_FRAME_TYPE_UNKNOWN,
	IDR_FRAME_TYPE_H20_SHOT_PHOTO,
	IDR_FRAME_TYPE_H20_RECORD_VIDEO,
	IDR_FRAME_TYPE_Z30_SHOT_PHOTO,
	IDR_FRAME_TYPE_Z30_RECORD_VIDEO,
};

/* Exported functions --------------------------------------------------------*/
ErrorCode::ErrorCodeType
H264IdrFrame_GetData(IdrFrameType idrFrameType, const uint8_t *&data, uint32_t &dataLen);

#endif // H264_IDR_FRAME_H
/************************ (C) COPYRIGHT DJI Innovations *******END OF FILE******/
